/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package tp2;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

/**
 *
 * @author ediltondossantos
 */
@Entity
public class CompteBancaire implements Serializable {
    private static final long serialVersionUID = 1L;


    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private int id;
    private String type;
    private int solde;
    @OneToMany(cascade={CascadeType.ALL}, fetch=FetchType.EAGER,mappedBy = "compteBancaire")
    private Collection<OperationBancaire> operations = new ArrayList();
    @ManyToOne(cascade={CascadeType.ALL}, fetch=FetchType.EAGER)
    private Client client;

    public CompteBancaire() {
    }

    public CompteBancaire(String type, int solde) {
        this.type = type;
        this.solde = solde;
    }

    public CompteBancaire creerCompte(String p,int s){
        CompteBancaire c=new CompteBancaire(p,s);
        return c;
    }

    public int consulter(){
        return solde;
    }

    public int deposer(int montant){
        solde+=montant;
        return montant;
    }

    public int retirer(int montant){
            solde-=montant;
            return montant;
    }



    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }
 public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public int getSolde() {
        return solde;
    }

    public void setSolde(int solde) {
        this.solde = solde;
    }

    public Collection<OperationBancaire> getOperations() {
        return operations;
    }


    public void setOperations(Collection<OperationBancaire> operations) {
        this.operations = operations;
    }

    public void addOperations(OperationBancaire op){
        Collection<OperationBancaire> cOp=this.operations;
        cOp.add(op);
        this.setOperations(cOp);
    }

    public Client getClient() {
        return client;
    }

    public void setClient(Client client) {
        this.client = client;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (int) id;
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof CompteBancaire)) {
            return false;
        }
        CompteBancaire other = (CompteBancaire) object;
        if (this.id != other.id) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "tp2.CompteBancaire[id=" + id + "]";
    }

}
